#ifndef types_h
#define types_h

#include <set>
#include <vector>
#include <assert.h>

typedef std::vector<int> IntVector;
typedef std::set<int> IntSet;
typedef std::vector<IntSet> IntSetVector;

typedef std::vector<bool> BoolVector;

class DoubleIntPair : public std::pair<double, int> {

public:
	DoubleIntPair(double d, int i) {
		first = d; second = i;
	}

	bool operator<(const DoubleIntPair &dip) const;
};

typedef std::vector<DoubleIntPair> DoubleIntPairVector;

//// unordered pair of ints, i.e., m_v1 < m_v2
//class IntUPair {
//public:
//	IntUPair() {
//		m_v1 = -1; m_v2 = -1;
//	}
//
//	// reorders if necessary
//	IntUPair(int v1, int v2)
//	{
//		assert(v1 != v2);
//		if (v1 < v2) {
//			m_v1 = v1; m_v2 = v2;
//		} else
//		{
//			m_v1 = v2; m_v2 = v1;
//		}
//	}
//	void swap() { int tmp = m_v2; m_v2 = m_v1; m_v1 = tmp; }	
//	bool operator<(const IntUPair &pj) const; // for sorting (discovering duplicates)	
//	bool operator==(const IntUPair &pj) const;
//	void assertOrder() const { assert(m_v1 < m_v2); }
//
//	inline int getV1() const { return m_v1; }
//	inline int getV2() const { return m_v2; }
//
//protected:
//	int m_v1, m_v2;
//};
//typedef std::vector<IntUPair> IntUPairList;

//class IntPairValue {
//public:
//	int m_v1, m_v2;
//	double m_value;
//	IntPair():m_v1(0),m_v2(0),m_value(0.0){}
//	IntPair(int v1, int v2, double val):m_v1(v1),m_v2(v2),m_value(val){}
//
//	void assertStrictOrdering() {
//		assert(m_v1 < m_v2);
//	}
//};
//typedef std::vector<IntPairValue> IntPairValueList;

typedef std::vector<double> DoubleVector;

#endif

